/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER         "0.1.1"
#define KEYPATH     "Software\\Ipswitch\\Messenger\\Version 1.0\\Settings"
#define BUFFSZ      1024
#define READREG(x)  len = BUFFSZ; \
                    if(RegQueryValueEx( \
                      key, \
                      x, \
                      NULL, \
                      NULL, \
                      buff, \
                      (void *)&len)) { \
                        fputs("\nError: impossible to read the registry key\n", stdout); \
                        fputs("\n   Press RETURN to exit\n", stdout); \
                        fgetc(stdin); \
                        exit(1); \
                    }



unsigned char *iim_pwd(unsigned char *data, int len);



int main(void) {
    HKEY            key;
    unsigned char   buff[BUFFSZ];
    int             len;


    setbuf(stdout, NULL);

    fputs("\n"
        "IpSwitch Instant Messaging client last password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(RegOpenKeyEx(HKEY_CURRENT_USER, KEYPATH, 0, KEY_READ, &key)) {
        fputs("\nError: registry key has not been found\n", stdout);
        fputs("\n   Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    READREG("LastUsername");
    printf("Username:   %s\n", buff);

    READREG("LastPassword");
    printf("Password:   %s\n", iim_pwd(buff, len));

    RegCloseKey(key);

    fputs("\n   Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



unsigned char *iim_pwd(unsigned char *data, int len) {
    unsigned char   *ret;
    unsigned int    tmp;

    if(*data != 0xff) return(data);
    ret = ++data;
    len--;
    while(len--) {
        tmp = *data ^ 0x55;
        *data++ = (tmp << 4) | (tmp >> 4);
    }
    *data = 0;
    return(ret);
}


